property movie_view : missing value
property movie_loaded : false
property titlebar_and_controller_offset : 38

on awake from nib the_object
	tell the_object
		set movie_view to view "movie"
		center
		show
	end tell
end awake from nib

on clicked the_object
	set object_name to (name of the_object) as Unicode text
	call method "makeKeyAndOrderFront:" of window "main"
	
	if object_name = "load_movie" then
		my load_movie()
		
	else if object_name = "log_properties" then
		log (call method "moviePropertiesForView:" of class "methods" with parameters {movie_view})
		
	else if object_name = "preserve_aspect" then
		call method "setPreservesAspectRatio:shouldPreserve:" of class "methods" with parameters {movie_view, state of the_object}
		
	else if object_name = "recenter" then
		tell window "main" to center
		
	else if object_name = "default_size" then
		set the_properties to (call method "moviePropertiesForView:" of class "methods" with parameters {movie_view})
		tell window "main"
			my enable_flush_window(false, it)
			set {x1, y1, x2, y2} to bounds
			set new_height to (the_properties's default_height) + titlebar_and_controller_offset
			set y1 to y2 - new_height
			set y2 to y1 + new_height
			if (the_properties's default_width > 0) then set x2 to x1 + (the_properties's default_width)
			set bounds to {x1, y1, x2, y2}
			center
			my enable_flush_window(true, it)
		end tell
		
	else if object_name starts with "size" then
		if object_name ends with "05" then
			set the_multiple to 0.5
		else
			set the_multiple to 2
		end if
		tell window "main"
			my enable_flush_window(false, it)
			set {h, w} to size
			set size to {h * the_multiple, w * the_multiple}
			center
			my enable_flush_window(true, it)
		end tell
		
	end if
end clicked

on should quit after last window closed the_object
	return true
end should quit after last window closed

on choose menu item the_object
	set object_name to (name of the_object) as Unicode text
	if object_name = "load_movie" then
		load_movie()
		
	end if
end choose menu item

on display_error(the_title, the_error)
	activate
	beep
	display alert the_title as critical message the_error default button "OK" attached to window "main"
end display_error

on load_movie()
	set the_movie_path to POSIX path of (choose file with prompt "Choose a movie:" without invisibles)
	set movie_loaded to (call method "loadMovie:withPath:" of class "methods" with parameters {movie_view, the_movie_path})
	set enabled of controls of window "controller" whose name is not "load_movie" to movie_loaded
	if movie_loaded then
		set the_properties to (call method "moviePropertiesForView:" of class "methods" with parameters {movie_view})
		tell window "main"
			set title to the_properties's display_name
			set {x1, y1, x2, y2} to bounds
			set new_height to (the_properties's default_height) + titlebar_and_controller_offset
			set y1 to y2 - new_height
			set y2 to y1 + new_height
			if (the_properties's default_width > 0) then set x2 to x1 + (the_properties's default_width)
			set bounds to {x1, y1, x2, y2}
			center
			call method "makeKeyAndOrderFront:" of it
		end tell
	else
		my display_error("Load Error", "Could not load the file " & the_movie_path & " as a movie. Please try another file.")
	end if
end load_movie

on enable_flush_window(enable_flush, the_window)
	call method ({"disableFlushWindow", "enableFlushWindow"}'s item ((enable_flush as integer) + 1)) of the_window
end enable_flush_window
